#include <ESP8266mDNS.h>

//BE SURE TO HIDE YOUR SSID AND PW IF PUBLISHING!!

#include <ESP8266WiFi.h>

#include <OneWire.h>

//SEE WELCOME MESSAGE IN setup() for VERSION ID
//Mk2 started 4 Jan 17
//Mk1 started 30 Dec 16, 15:35... deathly ill with aweful cold.
//First "big" ESP8266 prgm... but still mostly the Sparkfun WebServer example.

//BE SURE TO HIDE YOUR SSID AND PW IF PUBLISHING!!

//ESP8266_web_server_for_FW002_Mk2
//N.B. Name is in Serial Monitor output.

//The earlier one ("ESP8266_web_server_for_FW002_Mk2") was
//crude... but even so, it worked! Reported tture from a DS18B20,
//and counted anemometer pulses, and provided a FW002-friendly
//web page.

//Mk2 put the reading of the DS18B20 on a much more sensible
//footing, using ideas in
////sg/arduino/DS18B20-HowTo.htm


//Web-server elements derived from Sparkfun example...
//https://learn.sparkfun.com/tutorials/esp8266-thing-development-board-hookup-guide/example-sketch-web-server

//FOR ANY DERIVATIVE STILL USING THE WiFi CAPABILITIES...
//  YOU MUST TWEAK CODE TO REFLECT YOUR LOCATION....
//  AND THOSE TWEAKS NEED TO BE KEPT **secret**
//     See WiFi Definitions section, a few lines below

//You may also need to assign the device to a non-standard port,
//  if you are already using port 80 for a different web server
//  the same LAN. You do this with the line "WiFiServer server(xx);"

//////////////////////
// WiFi Definitions //
//////////////////////
//Tweak next two for your WiFi environment, and take
//  care not to tell people who shouldn't know
//  what settings you've supplied to the Thing...
const char WiFiSSID[] = "YOU MUST PUT YOURS HERE";
const char WiFiPSK[] = "YOU MUST PUT YOURS HERE";

WiFiServer server(1200);

//THREE LINES ADDED BY TKB TO BASIC DEMO.... Block 1 of 2 to set static IP address
IPAddress ip(192, 168, 0, 210);
IPAddress gateway(192,168,0,1);
IPAddress subnet(255,255,255,0);

/////////////////////
// Pin Definitions //
/////////////////////
const int LED_PIN=15;//Put LED and resistor from this pin to Gnd,
  //if one not already provided on board. (Sparkfun ESP8266 has LED+resistor on line 5.
  //"ordinary Arduinos usually have one on line 13.
const int ANALOG_PIN=A0; // The only analog pin on the Thing
//For Arduserver app, a light sensor should be wired to ANALOG_PIN, and it should be
//   arranged so that the LED the user can turn on and off provides most of the light
//   illuminating the light sensor.
const int DIGITAL_PIN=12; // Digital pin to be read

//BEGIN TKB BLOCK relating to creating something for FW002 to "watch"...
//The Webserver demo software from Sparkfun uses the built in LED to demo
//  setting/ clearing an output. It refers to the pin as LED_PIN
//For some prelim testing, I was ALSO using that... under name LED_PIN_TKB_dbl_USE

const byte Pin_AnemomInput=13;//The anemometer should pull this line LOW when it has
  //rotated to a certain postion (or positions) in its normal rotation. The pin is
  //configured INPUT_PULLUP, so you don't need to put a pull-up on the line.
  
const byte Pin_ShowAnemomInputStatus=5;//Put LED and resistor from this pin to Gnd,
  //if one not already provided on board. (Sparkfun ESP8266 has LED+resistor on line 5.
  //"ordinary" Arduinos usually have one on line 13.
  //I had some tedious issues with LEDs being on when they should be off, and vice versa
  //... but they were consistent. I also had a hassle in that if I connected an LED from pin
  //    15, through a 1k resistor, to 3V3, I could no longer do uploads. But my pin 15
  //    was being odd in other ways, too.


long int liLoopCycleCount =0;
int iTmp;

//END TKB BLOCK relating to creating something for FW002 to "watch"...

//THIS BLOCK ADDED, TKB, 1 Jan 17 for read-DS18B20 tture sensor wants...
//See a different read-DS18B20 block for source of ideas uses.

//For this code to compile, you need to add the "OneWire" library to your Arduino IDE.
//(And, no, the "Wire" library is NOT what I am talking about!)

unsigned long ulMillisAtPrevTenthsBump;
unsigned long ulTmp;
long int liTenthsPassed=0;
long int liTenthsPassedPrev=0;
long int liTenthsPassedWhenConvertRequested;
 
//End block added for read-DS18B20

//--------
//THIS BLOCK ADDED, TKB, 1 Jan 17 for read-DS18B20 tture sensor wants... based on material at...
//http://www.elec-cafe.com/temperature-sensor-on-the-web-with-esp8266-and-ds18b20/

OneWire  ds(4);  // on pin 4 (a 4.7K resistor pull up to the system's 3v3 is necessary, too)

byte i;
byte present = 0;
byte type_s;
byte data[12];
byte addr[8];
float celsius, fahrenheit, celsiusX10;

//...and to "stuff" into web-page...
//(there must be a better way!... (But I wanted a fixed format, e.g.
//"+025" for 2.5 deg C, or "-128" for -12.8 deg C.)

char cSTture0 ='+';
char cTturDC0Huns ='0';//Temperature, in Celcuis DECIdecgrees... i.e. 12.4 degC is 124 deg
char cTturDC0Tens ='0';
char cTturDC0Units ='0';

//END BLOCK ADDED BY TKB for read-DS18B20
//-------------------

//THIS BLOCK ADDED, TKB, 30 Dec 16 for FW002 wants...
char sTKB4Char0[4];
boolean boIpFrmAnemomHigh =false;
boolean boIpFrmAnemomHighPrev =false;
long int liPulsesAnemom = 0000;
long int liTmp;

//... and to "stuff" reading into web-page... there must be a
//better way! (But I wanted always 4 digits, so "0002" when
//only two pulses counted so far on anemometer input.)
char cAnemomThous ='0';
char cAnemomHuns ='0';
char cAnemomTens ='0';
char cAnemomUnits ='0';

//END BLOCK ADDED BY TKB for FW002 wants...

//"Prototypes"... helps compiler find things defined on tabs. See....
//http://jgarduino.blogspot.com/2013/04/arduino-ide-multiple-tabs-and-was-not.html
void LED_On_ForFWW();//prototype of sr defined on a tab
void LED_Off_ForFWW();// (prevents "not declared in this scope" "errors")
void OneWireCheckChipAndInitVars();// ditto
void OneWireAskThatReadingBeStarted();// ditto
void OneWireFetchReadingThatWasTaken();// ditto
void OneWireProcessCelsiusToOther();// ditto

//More prototypes. These routines on "From Sparkfun" tab...
void connectWiFi();
void setupMDNS();
void initHardware();

void setup() 
{
  initHardware();
  connectWiFi();//I could have sworn this was "connectWiFi() on Sparkfun page, only a day or
    // 3 before 1 Jan 17. On 1 Jan 17, they have setupWiFi() here... ON THE "ESP8266
    // Thing (not Dev Board)" page! On ESP8266 Thing DEV BOARD page it is INDEED "connectWiFi".
    //and THAT, in any case, is just a call to a page within this.

    //ARGH!!!! Two hours wasted "initHardware not declared in this scope" NOT TRUE... but you
    //may, at randon?? get that when trying to compile. If you do, move setup() and loop() to
    //bottom of code
    //ARGH ends.
    
  server.begin();
  setupMDNS();

//THIS BLOCK ADDED, TKB, 1 Jan 17 for read-DS18B20 tture sensor wants...
//See a different read-DS18B20 block for source of ideas uses.

Serial.println(" ");
Serial.println(" ");
Serial.println("Welcome to  ESP8266_web_server_for_FW002_Mk2");
Serial.println("by TK Boyd");
Serial.println("vers 6 Jan 17");//THIS LINE defines OFFICIAL "version" of this s/w
Serial.println(" ");
Serial.println("See.... ");
Serial.println("     http://sheepdogguides.com/arduino/DS18B20-HowTo.htm");
Serial.println("for details of reading DS18B20 with ESP8266, or indeed any Arduino.");
Serial.println(" ");
delay(1500);//so human can read above.

ulMillisAtPrevTenthsBump=millis();
 
//The following was inside loop() only, in the material I drew upon
//to build this...

OneWireCheckChipAndInitVars();

//END BLOCK ADDED BY TKB for read-DS18B20
//END BLOCK ADDED BY TKB for FW002



} //end of setup()

void loop() 
{

//THIS BLOCK ADDED, TKB, 30 Dec 16 for FW002 wants...
  //LED_On_ForFWW();//Something from TKB, in tab "TKB_Bits_FWW"
  liLoopCycleCount++;
   if ((liLoopCycleCount % 60000) == 1)
   {

    //REARRANGE WHAT APPEARS WHEN....
    
    Serial.print("liLoopCycleCount= ");
    Serial.print(liLoopCycleCount);
    Serial.print("  liTenthsPassed= ");
    Serial.print(liTenthsPassed);
    Serial.print("  liPulsesAnemom= ");
    Serial.print(liPulsesAnemom);
    Serial.print("  Anemom as 4 digits= ");
    Serial.print(cAnemomThous);
    Serial.print(cAnemomHuns);
    Serial.print(cAnemomTens);
    Serial.println(cAnemomUnits);
   }//end of what you do, if ((liLoopCycleCount % 60000) == 1)...
   
//THIS BLOCK ADDED, TKB, 30 Dec 16, inside block added for FW002 wants,
//for read-DS18B20 tture sensor wants...
//See a different read-DS18B20 block for source of ideas uses.

//Begin code to track tenths of seconds (or periods of a bit more) elapsed...
//This oft executed block also "watches" input from anemometer...

if ((liLoopCycleCount % 100)==0)
{    
     ulTmp=millis();
   if (ulTmp<ulMillisAtPrevTenthsBump)
     {ulMillisAtPrevTenthsBump=ulTmp;};
     //this handles rollover of millis.
     //this "tenth of a second" will be up
     //to 2/10th of a second long. I can live
     //with this "extra" error in 50 days!

   if (ulTmp>ulMillisAtPrevTenthsBump+100)
      { //Tenth passed
       liTenthsPassed++;
       ulMillisAtPrevTenthsBump=ulTmp;
       //I am not... yet... worring about what
       //happens when liTenthsPassed rolls over.
       //I must.. sigh... someday... maybe.
       //MAY not matter... but be SURE it doesn't.
      };

/*For debug... you probably DON'T want this block enabled, normally... the
program will probably get ahead of the bottleneck of the relatively slow
channel to the serial monitor and maybe do Weird Stuff... but it does "work"
for ten seconds, at least, at a time, if you need to check when/ what is
happening...
   Serial.print(liLoopCycleCount);
   Serial.print(" x ");
   Serial.print(ulMillisAtPrevTenthsBump);
   Serial.print(" x ");
   Serial.println(liTenthsPassed);
   */

//The oft executed block we are in also "watches" input from anemometer,
//by means of the following...
   if (digitalRead(Pin_AnemomInput)==HIGH)
   {LED_On_ForFWW();
   boIpFrmAnemomHigh=true;}
   else
   {LED_Off_ForFWW();
    boIpFrmAnemomHigh=false;};

   if (boIpFrmAnemomHigh != boIpFrmAnemomHighPrev)
     {
      boIpFrmAnemomHighPrev=boIpFrmAnemomHigh;
      liPulsesAnemom++;
     }

};//End code to track tenths of seconds (or periods of a bit more) elapsed.

if ((liTenthsPassed%100)==5)
{
  //Without next two lines, sometimes this block will
  //execute more than once when liTenthsPassed%100)==5,
  //because loop() can complete and start again before
  //liTenthsPassed has been incremented again.
  if (liTenthsPassed!=liTenthsPassedPrev)
  {
      liTenthsPassedPrev=liTenthsPassed;
      
      OneWireAskThatReadingBeStarted();
  }
}//end of "if ((liTenthsPassed%100)==5).."

/*TAKEN OUT from version done by elec-cafe...

    delay(1000);//CRUDE and UNSATISFACTORY "answer"

Replaced by the tenths-of-second-counter and the...
  if ((liTenthsPassed%100)==5)
  .... and....
  if ((liTenthsPassed%100)==16)
*/

if ((liTenthsPassed%100)==16)
{
  //Without next two lines, sometimes this block will
  //execute more than once when liTenthsPassed%100)==16,
  //because loop() can complete and start again before
  //liTenthsPassed has been incremented again.
  if (liTenthsPassed!=liTenthsPassedPrev)
    {
      liTenthsPassedPrev=liTenthsPassed;
      
     OneWireFetchReadingThatWasTaken();
     OneWireProcessCelsiusToOther();
  
     Serial.print("Temperature (deg C) = ");
     Serial.println(celsius);
     /*
     Serial.print(" Celsius, ");
     Serial.print(fahrenheit);
     Serial.println(" Fahrenheit");
     */

  }
};//end of "if ((liTenthsPassed%100)==16)"

//END BLOCK ADDED BY TKB for read-DS18B20

/*
  There must be a better way!!... but, for now, this "works". Ick.
  NOW NEED TO UPDATE...
  s +=cAnemomThous;
  s +=cAnemomHunss;
  s +=cAnemomTens;
  s +=cAnemomUnits;  
  
  Now move liPulsesAnemom (a long int) to the
  four "char" variables set up to hold the
  ASCII of the four LS(digital)Ds of that
  value. (The chars are subsequently sent
  to the web-page served, so that FWW (or
  humans) can access the values.)
*/

  liTmp=liPulsesAnemom%10000;
    cAnemomThous=(liTmp /1000)+48;
  liTmp=liPulsesAnemom%1000;
    cAnemomHuns=(liTmp /100)+48;
  liTmp=liPulsesAnemom%100;
    cAnemomTens=(liTmp /10)+48;
  
  cAnemomUnits=(liTmp%10)+48;


//END BLOCK ADDED BY TKB for FWW002
  
  // Check if a client has connected
  WiFiClient client = server.available();
  if (!client) {
    return;
  }

  // Read the first line of the request
  String req = client.readStringUntil('\r');
  Serial.println(req);
  client.flush();

  // Match the request
  int val = -1; // We'll use 'val' to keep track of both the
                // request type (read/set) and value if set.
  if (req.indexOf("/led/0") != -1)
    val = 1; // Will write LED high
  else if (req.indexOf("/led/1") != -1)
    val = 0; // Will write LED low
  else if (req.indexOf("/read") != -1)
    val = -2; // Will print pin reads
  // Otherwise request will be invalid. We'll say as much in HTML

  //============
  // Set LED_PIN according to the request
  //If using the onboard LED(+resistor) of the ESP8266, the following works...
  if (val >= 0)
    digitalWrite(LED_PIN, val);
  //If using an external LED on a different IO pin, and the LED goes 

  client.flush();

  // Prepare the response. Start with the common header:
  String s = "HTTP/1.1 200 OK\r\n";
  s += "Content-Type: text/html\r\n\r\n";
  s += "<!DOCTYPE HTML>\r\n<html>\r\n";

  //THIS BLOCK ADDED, TKB, 30 Dec 16 for FW002 wants...

  //Nasty, kludgy version to allow me to skive (for now) modifying FW002.
  //This works with FW002 vers 13 Oct 16, 21:50

  s += "<h2>Yet Another Arduserver!</h2><br>";
  s += "<p>Created early Jan 2017, using the wonderful ESP8266 ""Thing"" from Sparkfun,";
  s += "and the software provided by them and by others. (See code)</p>\r\n";
  
  s += "<p>The hardware that is serving this page cost $16. For details, see ";

  s += "<a href=""http://sheepdogguides.com/elec/misc/esp8266/Esp8266-Arduserver.htm"" target=""_blank"">";
  s += "my page with the details, including the sourcecode, for the server this comes from.</a><p>\r\n";

  s += "<p>An Arduserver is a little demo of how you can set up a small web-server which will ";
  s += "allow someone with a browser to control outputs and read inputs remotely, across the internet ";
  s += "with nothing more than a browswer.<p>\r\n";
  s += "<p>Furthermore, due to the following two ""odd"" lines, the Arduserver is ""machine friendly"", and ";
  s += "data can be read from the Arduserver by programs running in computers elsewhere. So, for instance, ";
  s += "if you wanted an alarm to ring at location ""A"" when the temperature at location ""B"" dropped below ";
  s += "say, 40 degrees Fahrenheit, that could be arranged if you had an Arduserver at ""B"", and an ";
  s += "automatic ""Watch the Arduserver"" program running at ""A"".</p>\r\n";

  s += "<!--The next line must be the 8th line of the html generated, if FW002 is to read it easily.-->\r\n";
  s += "hhhhsttthhhhsttt<br>\r\n";

  //and the NEXT line must come immediately after the previous, for FW002's needs.
  //(FW002 is a program for watching what the server is serving, and drawing graphs
  //   from the numbers.)
  
  //Could the following be done more crudely?? BAH!
  //N.b: Can't do "ab"+"cd" to get "abcd" (!)

  s +=cAnemomThous;
  s +=cAnemomHuns;
  s +=cAnemomTens;
  s +=cAnemomUnits;

  if (cSTture0=='+')
  {
   s += "+";
  } else
  {
   s += "-";    
  }
  
  s +=cTturDC0Huns;//Temperature, in Celcuis DECIdecgrees... i.e. 12.4 degC is 124 deg
  s +=cTturDC0Tens;
  s +=cTturDC0Units;
 
  s += "0287+242<br>\r\n";//These characters... for now... unchanging and meaningless.
  //They can easily be replaced by dynamic values from, say, another temperature sensor
  //and another pulse counter.
  s += "<br><br>\r\n";
  //END BLOCK ADDED BY TKB
  
  // If we're setting the LED, print out a message saying we did
  if (val >= 0)
  {
    s += "LED is now ";
    s += (val)?"off":"on";
  }
  else if (val == -2)
  { // If we're reading pins, print out those values:
    s += "Analog Pin = ";
    s += String(analogRead(ANALOG_PIN));
    s += "<br>"; // Go to the next line.
    s += "Digital Pin 12 = ";
    s += String(digitalRead(DIGITAL_PIN));
  }
  else
  {
    s += "Invalid Request.<br> Try /led/1, /led/0, or /read.";
  }

  s += "<br><br>"; 
  s += "<h3>A little test... will a larger 'page' 'break' the server?</h3>"; 
  s += "<p>1-123456789012345678901234567890</p>"; 
  s += "<p>2-123456789012345678901234567890</p>"; 
  s += "<p>3-123456789012345678901234567890</p>"; 
  s += "<p>4-123456789012345678901234567890</p>"; 
  s += "<p>5-123456789012345678901234567890</p>"; 
  s += "<p>6-123456789012345678901234567890</p>"; 
  s += "<p>7-123456789012345678901234567890</p>"; 
  s += "<p>8-123456789012345678901234567890</p>"; 
  s += "<p>9-123456789012345678901234567890</p>"; 
  s += "<p>10-123456789012345678901234567890</p>"; 
  
  s += "<p>11-123456789012345678901234567890</p>"; 
  s += "<p>12-123456789012345678901234567890</p>"; 
  s += "<p>13-123456789012345678901234567890</p>"; 
  s += "<p>14-123456789012345678901234567890</p>"; 
  s += "<p>15-123456789012345678901234567890</p>"; 
  s += "<p>16-123456789012345678901234567890</p>"; 
  s += "<p>17-123456789012345678901234567890</p>"; 
  s += "<p>18-123456789012345678901234567890</p>"; 
  s += "<p>19-123456789012345678901234567890</p>"; 
  s += "<p>20-123456789012345678901234567890</p>"; 
  
  s += "<p>21-123456789012345678901234567890</p>"; 
  s += "<p>22-123456789012345678901234567890</p>"; 
  s += "<p>23-123456789012345678901234567890</p>"; 
  s += "<p>24-123456789012345678901234567890</p>"; 
  s += "<p>25-123456789012345678901234567890</p>"; 
  s += "<p>26-123456789012345678901234567890</p>"; 
  s += "<p>27-123456789012345678901234567890</p>"; 
  s += "<p>28-123456789012345678901234567890</p>"; 
  s += "<p>29-123456789012345678901234567890</p>"; 
  s += "<p>30-123456789012345678901234567890</p>"; 

  s += "<br><br><p>Hmmmm... it seems that the web server creation "; 
  s += "is more robust than once it was. A page this 'big' would have "; 
  s += "caused arcane and tedious problems once upon a time. Hurrah "; 
  s += "for THIS kind of 'progress'!</p>"; 
  s += "<p>It also seems that the 's+=' mechanism (see code) is quite "; 
  s += "powerful, and can handle a LONG string! (^_^)</p>"; 
  s += "<br><center>"; 
  s += "<h3>End of page from <a href=""http://Arduserver.com"" target=""_blank"">";
  s += "Arduserver.com/a></h3></center><br>"; 
  
  s += "</html>\n";

  // Send the response to the client
  client.print(s);
  delay(1);
  Serial.println("Client disonnected");

  // The client will actually be disconnected 
  // when the function returns and 'client' object is destroyed

}//of void loop()


